package com.qmth.distributed.print.business.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.qmth.distributed.print.business.entity.TFCustomFlow;
import com.qmth.distributed.print.business.enums.TFCustomTypeEnum;
import com.qmth.distributed.print.business.mapper.TFCustomFlowMapper;
import com.qmth.distributed.print.business.service.TFCustomFlowService;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.Objects;

/**
 * <p>
 * 自定义流程表 服务实现类
 * </p>
 *
 * @author wangliang
 * @since 2022-01-21
 */
@Service
public class TFCustomFlowServiceImpl extends ServiceImpl<TFCustomFlowMapper, TFCustomFlow> implements TFCustomFlowService {

    @Resource
    TFCustomFlowMapper tfCustomFlowMapper;

    /**
     * 查询版本号
     *
     * @param schoolId
     * @param orgId
     * @param type
     * @return
     */
    @Override
    public Integer findMaxVersion(Long schoolId, Long orgId, TFCustomTypeEnum type) {
        return tfCustomFlowMapper.findMaxVersion(schoolId, orgId, Objects.nonNull(type) ? type.name() : null);
    }

    /**
     * 根据流程id查找
     *
     * @param flowId
     * @return
     */
    @Override
    public TFCustomFlow findByFlowId(Long flowId) {
        QueryWrapper<TFCustomFlow> tfCustomFlowQueryWrapper = new QueryWrapper<>();
        tfCustomFlowQueryWrapper.lambda().eq(TFCustomFlow::getFlowId, flowId);
        return this.getOne(tfCustomFlowQueryWrapper);
    }
}
